Index: pykota/trunk/pykota/version.py
===================================================================
--- pykota/trunk/pykota/version.py (revision 2600)
+++ pykota/trunk/pykota/version.py (revision 2609)
@@ -22,5 +22,5 @@
 #
 
-__version__ = "1.24alpha5_unofficial"
+__version__ = "1.24alpha6_unofficial"
 
 __doc__ = "PyKota : a complete Printing Quota Solution for CUPS."
Index: pykota/trunk/bin/edpykota
===================================================================
--- pykota/trunk/bin/edpykota (revision 2515)
+++ pykota/trunk/bin/edpykota (revision 2609)
@@ -613,6 +613,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :     
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/pykotme
===================================================================
--- pykota/trunk/bin/pykotme (revision 2524)
+++ pykota/trunk/bin/pykotme (revision 2609)
@@ -151,6 +151,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/pkbcodes
===================================================================
--- pykota/trunk/bin/pkbcodes (revision 2554)
+++ pykota/trunk/bin/pkbcodes (revision 2609)
@@ -167,6 +167,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/pkturnkey
===================================================================
--- pykota/trunk/bin/pkturnkey (revision 2512)
+++ pykota/trunk/bin/pkturnkey (revision 2609)
@@ -492,6 +492,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/pykoef
===================================================================
--- pykota/trunk/bin/pykoef (revision 2572)
+++ pykota/trunk/bin/pykoef (revision 2609)
@@ -131,6 +131,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/repykota
===================================================================
--- pykota/trunk/bin/repykota (revision 2512)
+++ pykota/trunk/bin/repykota (revision 2609)
@@ -160,6 +160,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/warnpykota
===================================================================
--- pykota/trunk/bin/warnpykota (revision 2547)
+++ pykota/trunk/bin/warnpykota (revision 2609)
@@ -160,6 +160,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/pkbanner
===================================================================
--- pykota/trunk/bin/pkbanner (revision 2512)
+++ pykota/trunk/bin/pkbanner (revision 2609)
@@ -312,6 +312,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/autopykota
===================================================================
--- pykota/trunk/bin/autopykota (revision 2512)
+++ pykota/trunk/bin/autopykota (revision 2609)
@@ -120,6 +120,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/pkprinters
===================================================================
--- pykota/trunk/bin/pkprinters (revision 2512)
+++ pykota/trunk/bin/pkprinters (revision 2609)
@@ -264,6 +264,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/pykosd
===================================================================
--- pykota/trunk/bin/pykosd (revision 2544)
+++ pykota/trunk/bin/pykosd (revision 2609)
@@ -194,6 +194,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/pkmail
===================================================================
--- pykota/trunk/bin/pkmail (revision 2512)
+++ pykota/trunk/bin/pkmail (revision 2609)
@@ -159,6 +159,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/bin/dumpykota
===================================================================
--- pykota/trunk/bin/dumpykota (revision 2600)
+++ pykota/trunk/bin/dumpykota (revision 2609)
@@ -161,6 +161,8 @@
     except KeyboardInterrupt :        
         sys.stderr.write("\nInterrupted with Ctrl+C !\n")
+        retcode = -3
     except PyKotaCommandLineError, msg :    
         sys.stderr.write("%s : %s\n" % (sys.argv[0], msg))
+        retcode = -2
     except SystemExit :        
         pass
Index: pykota/trunk/NEWS
===================================================================
--- pykota/trunk/NEWS (revision 2605)
+++ pykota/trunk/NEWS (revision 2609)
@@ -22,4 +22,9 @@
 PyKota NEWS :
        
+    - 1.24alpha6 :
+    
+        - Now command line errors and Ctrl+C repectively cause
+          PyKota commands to exit with status -2 and -3.
+          
     - 1.24alpha5 :
     