Index: pykota/trunk/pykota/ipp.py
===================================================================
--- pykota/trunk/pykota/ipp.py (revision 2514)
+++ pykota/trunk/pykota/ipp.py (revision 2622)
@@ -6,5 +6,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/loggers/__init__.py
===================================================================
--- pykota/trunk/pykota/loggers/__init__.py (revision 2302)
+++ pykota/trunk/pykota/loggers/__init__.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/loggers/stderr.py
===================================================================
--- pykota/trunk/pykota/loggers/stderr.py (revision 2302)
+++ pykota/trunk/pykota/loggers/stderr.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/loggers/system.py
===================================================================
--- pykota/trunk/pykota/loggers/system.py (revision 2302)
+++ pykota/trunk/pykota/loggers/system.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/dumper.py
===================================================================
--- pykota/trunk/pykota/dumper.py (revision 2602)
+++ pykota/trunk/pykota/dumper.py (revision 2622)
@@ -3,5 +3,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/tool.py
===================================================================
--- pykota/trunk/pykota/tool.py (revision 2610)
+++ pykota/trunk/pykota/tool.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/reporters/__init__.py
===================================================================
--- pykota/trunk/pykota/reporters/__init__.py (revision 2302)
+++ pykota/trunk/pykota/reporters/__init__.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/reporters/html.py
===================================================================
--- pykota/trunk/pykota/reporters/html.py (revision 2302)
+++ pykota/trunk/pykota/reporters/html.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/reporters/text.py
===================================================================
--- pykota/trunk/pykota/reporters/text.py (revision 2302)
+++ pykota/trunk/pykota/reporters/text.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/__init__.py
===================================================================
--- pykota/trunk/pykota/__init__.py (revision 2302)
+++ pykota/trunk/pykota/__init__.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/accounters/software.py
===================================================================
--- pykota/trunk/pykota/accounters/software.py (revision 2409)
+++ pykota/trunk/pykota/accounters/software.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/accounters/hardware.py
===================================================================
--- pykota/trunk/pykota/accounters/hardware.py (revision 2425)
+++ pykota/trunk/pykota/accounters/hardware.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/accounters/snmp.py
===================================================================
--- pykota/trunk/pykota/accounters/snmp.py (revision 2618)
+++ pykota/trunk/pykota/accounters/snmp.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/accounters/__init__.py
===================================================================
--- pykota/trunk/pykota/accounters/__init__.py (revision 2302)
+++ pykota/trunk/pykota/accounters/__init__.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/accounters/pjl.py
===================================================================
--- pykota/trunk/pykota/accounters/pjl.py (revision 2620)
+++ pykota/trunk/pykota/accounters/pjl.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/logger.py
===================================================================
--- pykota/trunk/pykota/logger.py (revision 2302)
+++ pykota/trunk/pykota/logger.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/storages/pgstorage.py
===================================================================
--- pykota/trunk/pykota/storages/pgstorage.py (revision 2599)
+++ pykota/trunk/pykota/storages/pgstorage.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/storages/__init__.py
===================================================================
--- pykota/trunk/pykota/storages/__init__.py (revision 2302)
+++ pykota/trunk/pykota/storages/__init__.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/storages/sql.py
===================================================================
--- pykota/trunk/pykota/storages/sql.py (revision 2599)
+++ pykota/trunk/pykota/storages/sql.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/storages/dbistorage.py
===================================================================
--- pykota/trunk/pykota/storages/dbistorage.py (revision 2302)
+++ pykota/trunk/pykota/storages/dbistorage.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/storages/ldapstorage.py
===================================================================
--- pykota/trunk/pykota/storages/ldapstorage.py (revision 2538)
+++ pykota/trunk/pykota/storages/ldapstorage.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/storages/sqlitestorage.py
===================================================================
--- pykota/trunk/pykota/storages/sqlitestorage.py (revision 2593)
+++ pykota/trunk/pykota/storages/sqlitestorage.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/cgifuncs.py
===================================================================
--- pykota/trunk/pykota/cgifuncs.py (revision 2302)
+++ pykota/trunk/pykota/cgifuncs.py (revision 2622)
@@ -1,5 +1,5 @@
 # PyKota - Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/reporter.py
===================================================================
--- pykota/trunk/pykota/reporter.py (revision 2452)
+++ pykota/trunk/pykota/reporter.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/accounter.py
===================================================================
--- pykota/trunk/pykota/accounter.py (revision 2409)
+++ pykota/trunk/pykota/accounter.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/storage.py
===================================================================
--- pykota/trunk/pykota/storage.py (revision 2530)
+++ pykota/trunk/pykota/storage.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/config.py
===================================================================
--- pykota/trunk/pykota/config.py (revision 2593)
+++ pykota/trunk/pykota/config.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pykota/trunk/pykota/version.py
===================================================================
--- pykota/trunk/pykota/version.py (revision 2616)
+++ pykota/trunk/pykota/version.py (revision 2622)
@@ -4,5 +4,5 @@
 # PyKota : Print Quotas for CUPS and LPRng
 #
-# (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,5 +22,5 @@
 #
 
-__version__ = "1.24alpha6_unofficial"
+__version__ = "1.24alpha7_unofficial"
 
 __doc__ = "PyKota : a complete Printing Quota Solution for CUPS."